/* GKrellM
|  Copyright (C) 1999-2000 Bill Wilson
|
|  Author:  Bill Wilson    bill@gkrellm.net
|  Latest versions might be found at:  http://gkrellm.net
|
|  This program is free software which I release under the GNU General Public
|  License. You may redistribute and/or modify this program under the terms
|  of that license as published by the Free Software Foundation; either
|  version 2 of the License, or (at your option) any later version.
|
|  This program is distributed in the hope that it will be useful,
|  but WITHOUT ANY WARRANTY; without even the implied warranty of
|  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|  GNU General Public License for more details.
| 
|  To get a copy of the GNU General Puplic License, write to the Free Software
|  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/* Public GKrellM function prototypes available for all monitors and plugins */

Chart		*gkrellm_chart_new0(void);
Panel		*gkrellm_panel_new0(void);
Krell		*gkrellm_krell_new0(void);
Decal		*gkrellm_decal_new0(void);
Label		*gkrellm_label_new0(void);
Style		*gkrellm_style_new0(void);
TextStyle	*gkrellm_textstyle_new0(void);

Style			*gkrellm_meter_style(gint);
Style			*gkrellm_panel_style(gint n);
Style			*gkrellm_chart_style(gint n);
Style			*gkrellm_krell_slider_style(void);
Style			*gkrellm_krell_mini_style(void);

TextStyle *gkrellm_chart_textstyle(gint);
TextStyle *gkrellm_panel_textstyle(gint);
TextStyle *gkrellm_meter_textstyle(gint);
TextStyle *gkrellm_chart_alt_textstyle(gint);
TextStyle *gkrellm_panel_alt_textstyle(gint);
TextStyle *gkrellm_meter_alt_textstyle(gint);

GdkImlibImage 	*gkrellm_bg_chart_image(gint);
GdkImlibImage 	*gkrellm_bg_panel_image(gint);
GdkImlibImage 	*gkrellm_bg_meter_image(gint);
GdkImlibImage	*gkrellm_bg_slider_image(gint);
GdkImlibImage	*gkrellm_bg_timer_image();

GdkImlibImage 	*gkrellm_krell_panel_image(gint);
GdkImlibImage 	*gkrellm_krell_meter_image(gint);
GdkImlibImage	*gkrellm_krell_slider_image(void);
GdkImlibImage	*gkrellm_krell_mini_image(void);

GdkImlibBorder	*gkrellm_bg_slider_border(gint);
GdkImlibBorder	*gkrellm_bg_timer_border(void);


GdkPixmap		*gkrellm_data_in_pixmap();
GdkPixmap		*gkrellm_data_in_grid_pixmap();
GdkPixmap		*gkrellm_data_out_pixmap();
GdkPixmap		*gkrellm_data_out_grid_pixmap();
GdkPixmap		*gkrellm_decal_misc_pixmap(void);
GdkBitmap		*gkrellm_decal_misc_mask(void);

GdkGC			*gkrellm_draw_GC(gint);
GdkGC			*gkrellm_bit_GC(gint);
GdkFont			*gkrellm_default_font(gint);
GdkColor		*gkrellm_white_color(void);
GdkColor		*gkrellm_black_color(void);

gint			gkrellm_update_HZ(void);
gint			gkrellm_scale_mode(void);
gint			gkrellm_chart_width(void);
gint			gkrellm_chart_height(gint);
gint			gkrellm_max_chart_height();

void			gkrellm_monitor_height_adjust(gint);

void	gkrellm_message_window(gchar *title, gchar *message, GtkWidget *);
void	gkrellm_config_message_window(gchar *title, gchar *message,
							GtkWidget *);
void	gkrellm_add_info_text(GtkWidget *, gchar **, gint);

void	gkrellm_create_chart(GtkWidget *, Chart *, gint);
void	gkrellm_create_panel(GtkWidget *, Panel *, GdkImlibImage *);
void	gkrellm_configure_panel(Panel *, gchar *, Style *);
void	gkrellm_draw_panel_label(Panel *, GdkImlibImage *);

void	gkrellm_set_decal_button_index(DecalButton *, gint);
DecalButton  *gkrellm_make_decal_button(Panel *, Decal *, void (*func)(),
						void *, gint, gint);
DecalButton *gkrellm_make_overlay_button(Panel *, void (*func)(), void *,
						gint, gint, gint, gint,
						GdkImlibImage *, GdkImlibImage *);
DecalButton *gkrellm_put_decal_in_panel_button(Panel *, Decal *,
						void (*func)(), void *);
DecalButton *gkrellm_put_decal_in_meter_button(Panel *, Decal *,
						void (*func)(), void *);
DecalButton *gkrellm_put_label_in_panel_button(Panel *, void (*func)(),
						void *, gint pad);
DecalButton *gkrellm_put_label_in_meter_button(Panel *, void (*func)(),
						void *, gint pad);
DecalButton *gkrellm_decal_is_button(Decal *);

void	gkrellm_set_in_button_callback(DecalButton *, gint (*func)());
void	gkrellm_destroy_button(DecalButton *);

Krell	*gkrellm_create_krell(Panel *, GdkImlibImage *, Style *);
void	gkrellm_update_krell(Panel *, Krell *, gulong);

Decal	*gkrellm_create_decal_text(Panel *p, gchar *, TextStyle *, Style *,
						gint, gint, gint);
Decal	*gkrellm_create_decal_pixmap(Panel *, GdkPixmap *, GdkBitmap *, gint,
						Style *, gint, gint);
void	gkrellm_draw_decal_pixmap(Panel *, Decal *, gint);
void	gkrellm_draw_decal_text(Panel *, Decal *, gchar *, gint);


void	gkrellm_make_decal_visible(Panel *, Decal *);
void	gkrellm_make_decal_invisible(Panel *, Decal *);
gint	gkrellm_is_decal_visible(Decal *);


void	gkrellm_draw_layers(Panel *);
void	gkrellm_draw_layers_force(Panel *);

gint	gkrellm_render_to_pixmap(GdkImlibImage *, GdkPixmap **, GdkBitmap **,
						gint, gint);

void	gkrellm_alloc_chart_data(Chart *);
void	gkrellm_clear_chart(Chart *);
void	gkrellm_store_chart_data(Chart *, gulong, gulong, gulong);
void	gkrellm_draw_chart(Chart *);
void	gkrellm_reset_chart(Chart *);

void	gkrellm_destroy_chart(Chart *);
void	gkrellm_destroy_panel(Panel *);
void	gkrellm_destroy_krell(Krell *);
void	gkrellm_destroy_decal(Decal *);
void	gkrellm_destroy_krell_list(Panel *);
void	gkrellm_destroy_decal_list(Panel *);

void	gkrellm_pack_side_frames();
int		gkrellm_enable_visibility(int, int *, GtkWidget *, gint);

void	gkrellm_draw_string(GdkDrawable *, TextStyle *, gint, gint, gchar *);
gint	gkrellm_draw_chart_label(Chart *, TextStyle *, gint, gint, gchar *);

void	gkrellm_apply_launcher(GtkWidget **, GtkWidget **, Panel *,
								Launcher *, void (*func)());
GtkWidget *gkrellm_launcher_table_new(GtkWidget *, gint);
void	gkrellm_config_launcher(GtkWidget *, gint, GtkWidget **, GtkWidget **,
								gchar *, Launcher *);
void	gkrellm_setup_launcher(Panel *, Launcher *, gint, gint);
void	gkrellm_configure_tooltip(Panel *, Launcher *);
void	cb_launch_button(DecalButton *);


  /* As of 0.9.6 I want to move away from these last four routines.
  |  For now I'll keep them around to avoid breaking plugins.
  */
Decal   *gkrellm_create_text_decal(Panel *p, gchar *, TextStyle *, Style *,
                        gint, gint, gint);
Decal   *gkrellm_create_pixmap_decal(Panel *, GdkPixmap *, GdkBitmap *, gint,
                        Style *);
void    gkrellm_draw_pixmap_decal(Panel *, Decal *, gint);
void    gkrellm_draw_text_decal(Panel *, Decal *, gchar *, gint);
